
#define _GNU_SOURCE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <dlfcn.h> // for dlopen and dlsym


// Written by Thorsten Wissmann 2011
//  edu _at_ thorsten-wissmann.de
//  License: do what you want... there is not enough time for license


// all inspired by:
// http://uberhip.com/people/godber/interception/html/slide_6.html
// http://uberhip.com/people/godber/interception/html/slide_7.html

int unlink(const char* pathname) {
    static int (*orig_unlink)(const char* pathname) = NULL;
    if (!orig_unlink) {
        orig_unlink = dlsym(RTLD_NEXT, "unlink");
    }
    char* prefix = "/tmp/Flash";
    if (!strncmp(prefix, pathname, strlen(prefix))) {
        fprintf(stderr, "not unlinking %s\n", pathname);
#ifdef PSYCHOMODE
        if (fork() == 0) {
            char* player_cmd = "totem";
            execlp(player_cmd, player_cmd, pathname, NULL);
            exit(0);
        }
#endif
    } else {
        return orig_unlink(pathname);
    }
    return 0;
}



